#!/bin/bash

#reads text files into header files for the software COLD. These
#header files can then be included in the relevant c++ files. This
#means that compile-time data is compiled into the program.

thisdir=`echo "$0" | sed 's+/[^/]*$++'`

if test $# -eq 3
then

headerfile=$1
dataname=$2
datafile=$3

else if test $# -eq 2
then

headerfile=$1
dataname=`echo $headerfile | awk 'BEGIN{FS="."};{print $1}' | sed 's=.*/==' `
datafile=$2

else if test $# -eq 1
then

datafile=$1
dataname=`echo $datafile | awk 'BEGIN{FS="."};{print $1}' | sed 's=.*/==' `
headerfile=$dataname.h


fi
fi
fi

includeguard=`echo $headerfile | sed 's=.*/==' | tr a-z. A-Z_`
lines=`wc -l $datafile | awk '{print $1}'`
countname=NUM`echo $dataname | tr a-z A-Z`

$thisdir/autogenmessage $headerfile $0 $datafile

echo "#ifndef $includeguard" >> $headerfile
echo "#define $includeguard" >> $headerfile
echo "const char *$dataname[]={" >> $headerfile
awk 'a==1{ORS="\n";print ","};{ORS="";print "\""$0"\"";a=1}' $datafile >> $headerfile
echo "};" >> $headerfile
echo "#define $countname $lines" >> $headerfile
echo "#endif" >> $headerfile
